/*****************************************************************************
 *
 * Copyright (c) 2018-19, Eduard Gerlits, Paula Herber, Josef Treus
 * Westfälische Wilhelms-Universität Münster, AG Embedded Systems 
 * All rights reserved.
 *
 * This file is part of SysCSec
 *
 * SysCSec is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * SysCSec is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SysCSec.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *  Please report any problems or bugs to: sysc.sec@uni-muenster.de
 *
 ****************************************************************************/

#include <iostream>
#include <systemc.h>
#include "commons.h"

SC_MODULE(InputModule){

	// clock
	sc_in<bool> clk;

	// in
	sc_in<sc_biguint<160> > out;
	sc_in<bool> done;

	// out
	sc_out<sc_biguint<160> > y;
	sc_out<sc_biguint<160> > m;
	sc_out<bool> en;



	void input_test(sc_biguint<160> param_y, sc_biguint<160> param_m){		
		std::cout << "[" << sc_time_stamp() << "]: " << "Write y value: " << param_y << std::endl;
		y->write(param_y);
		std::cout << "[" << sc_time_stamp() << "]: " << "Write m value: " << param_m << std::endl;
		m->write(param_m);
		std::cout << "[" << sc_time_stamp() << "]: " << "Activate module ..." << std::endl;
		en->write(true);

		wait();

		while(done->read()==false){
			std::cout << "[" << sc_time_stamp() << "]: " << "Computing ..." << std::endl;
			wait();
		}

		
		sc_biguint<160> val = out->read();
		std::cout << "[" << sc_time_stamp() << "]: " << "Computed value: " << val << std::endl;
		en->write(false);	
	}

	void exe(){
	  //sc_time t1(100, "SC_MS");
		wait();
		input_test(2,17);
		wait();
		input_test(5,17);
		wait();
		input_test(8,17);
		wait();
		input_test(11,17);
		wait();
		input_test(13,17);
		sc_stop();
	}

	SC_CTOR(InputModule){
		SC_THREAD(exe);
		sensitive << clk;
	}

};
